// ALANTIA (PC98) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*26*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int dn = -1;

	// Disk
	struct fpos md[] =
	{
		{ 0x31, 0x0b, 0x3a, 0x1d05 },	// I[vjOAj[V
		{ 0x32, 0x0e, 0x3f, 0x05fc },	// Ways
		{ 0x32, 0x14, 0x3b, 0x054b },	// Wizardly
		{ 0x32, 0x19, 0x86, 0x04c4 },	// Reflecting In My Mind
		{ 0x33, 0x04, 0x4b, 0x061e },	// Lonely Tracer
		{ 0x33, 0x0a, 0x69, 0x0708 },	// Somebody There
		{ 0x33, 0x11, 0x71, 0x0131 },	// j[WO
		{ 0x33, 0x12, 0xa2, 0x01fb },	// 
		{ 0x33, 0x14, 0x9d, 0x0159 },	// Moon Light
		{ 0x33, 0x15, 0xf6, 0x01d3 },	// Long Lost Lover
		{ 0x33, 0x17, 0xc9, 0x0459 },	// Look In Your Eyes
		{ 0x00, 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'1';
		if (dn<0 || dn>3)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x1a);
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x01, buff, 0x100);

		if ((buff[0x10]==0xbd && dn==-1) || dn==0)
		{
			printf("Disk 1 F܂.\n");
			fcut("DRIVER", 0x8e, 0x47, 0x00, 0x01, 0x01, 0x00, 0xec00);
			fcut("DATA",   0x8b, 0x45, 0x01, 0x06, 0x01, 0xa9, 0x395e);
			// ȃf[^؂o
			for (i=0; md[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, md[i].ofs, md[i].size);
			}
			break;
		}
		else if ((buff[0x10]==0x0f && dn==-1) || dn==1)
		{
			printf("Disk 2 F܂.\n");
			break;
		}
		else if ((buff[0x10]==0x01 && dn==-1) || dn==2)
		{
			printf("Disk 3 F܂.\n");
			break;
		}
	}
	return 0;
}

